# -*- coding: utf-8 -*-
from setuptools import setup

packages = \
['python_opendota',
 'python_opendota.api',
 'python_opendota.apis',
 'python_opendota.model',
 'python_opendota.models']

package_data = \
{'': ['*']}

install_requires = \
['python-dateutil>=2.8.2,<3.0.0', 'urllib3>=1.26.9,<2.0.0']

setup_kwargs = {
    'name': 'python-opendota',
    'version': '1.0.1',
    'description': 'OpenDota API',
    'long_description': '# python-opendota\nGenerated Python SDK for working with [OpenDota API](https://docs.opendota.com/).\n\nThis Python package is automatically generated by the [OpenAPI Generator](https://openapi-generator.tech) project:\n\n- API version: 18.0.0\n- Package version: 1.0.1\n- Build package: org.openapitools.codegen.languages.PythonClientCodegen\n\n## Requirements.\n\nPython >=3.6\n\n## Installation & Usage\n### pip install\n\nYou can install directly using:\n\n```sh\npip install git+https://github.com/swimmwatch/python-opendota.git\n```\n(you may need to run `pip` with root permission: `sudo pip install git+https://github.com/swimmwatch/python-opendota.git`)\n\nor:\n\n```sh\npip install python-opendota\n```\n\nThen import the package:\n```python\nimport python_opendota\n```\n\n### Poetry\n\nInstall via [Poetry](https://python-poetry.org/).\n\n```sh\npoetry add python-opendota\n```\n\nThen import the package:\n```python\nimport python_opendota\n```\n\n## Getting Started\n\nPlease follow the [installation procedure](#installation--usage) and then run the following:\n\n```python\n\nimport time\nimport python_opendota\nfrom pprint import pprint\nfrom python_opendota.api import benchmarks_api\nfrom python_opendota.model.benchmarks_response import BenchmarksResponse\n# Defining the host is optional and defaults to http://api.opendota.com/api\n# See configuration.py for a list of all supported configuration parameters.\nconfiguration = python_opendota.Configuration(\n    host = "http://api.opendota.com/api"\n)\n\n\n\n# Enter a context with an instance of the API client\nwith python_opendota.ApiClient(configuration) as api_client:\n    # Create an instance of the API class\n    api_instance = benchmarks_api.BenchmarksApi(api_client)\n    hero_id = "hero_id_example" # str | Hero ID\n\n    try:\n        # GET /benchmarks\n        api_response = api_instance.benchmarks_get(hero_id)\n        pprint(api_response)\n    except python_opendota.ApiException as e:\n        print("Exception when calling BenchmarksApi->benchmarks_get: %s\\n" % e)\n```\n\n## Documentation for API Endpoints\n\nAll URIs are relative to *http://api.opendota.com/api*\n\nClass | Method | HTTP request | Description\n------------ | ------------- | ------------- | -------------\n*BenchmarksApi* | [**benchmarks_get**](docs/BenchmarksApi.md#benchmarks_get) | **GET** /benchmarks | GET /benchmarks\n*ConstantsApi* | [**constants_get**](docs/ConstantsApi.md#constants_get) | **GET** /constants | GET /constants\n*ConstantsApi* | [**constants_resource_get**](docs/ConstantsApi.md#constants_resource_get) | **GET** /constants/{resource} | GET /constants\n*DistributionsApi* | [**distributions_get**](docs/DistributionsApi.md#distributions_get) | **GET** /distributions | GET /distributions\n*ExplorerApi* | [**explorer_get**](docs/ExplorerApi.md#explorer_get) | **GET** /explorer | GET /explorer\n*FindMatchesApi* | [**find_matches_get**](docs/FindMatchesApi.md#find_matches_get) | **GET** /findMatches | GET /\n*HealthApi* | [**health_get**](docs/HealthApi.md#health_get) | **GET** /health | GET /health\n*HeroStatsApi* | [**hero_stats_get**](docs/HeroStatsApi.md#hero_stats_get) | **GET** /heroStats | GET /heroStats\n*HeroesApi* | [**heroes_get**](docs/HeroesApi.md#heroes_get) | **GET** /heroes | GET /heroes\n*HeroesApi* | [**heroes_hero_id_durations_get**](docs/HeroesApi.md#heroes_hero_id_durations_get) | **GET** /heroes/{hero_id}/durations | GET /heroes/{hero_id}/durations\n*HeroesApi* | [**heroes_hero_id_item_popularity_get**](docs/HeroesApi.md#heroes_hero_id_item_popularity_get) | **GET** /heroes/{hero_id}/itemPopularity | GET /heroes/{hero_id}/itemPopularity\n*HeroesApi* | [**heroes_hero_id_matches_get**](docs/HeroesApi.md#heroes_hero_id_matches_get) | **GET** /heroes/{hero_id}/matches | GET /heroes/{hero_id}/matches\n*HeroesApi* | [**heroes_hero_id_matchups_get**](docs/HeroesApi.md#heroes_hero_id_matchups_get) | **GET** /heroes/{hero_id}/matchups | GET /heroes/{hero_id}/matchups\n*HeroesApi* | [**heroes_hero_id_players_get**](docs/HeroesApi.md#heroes_hero_id_players_get) | **GET** /heroes/{hero_id}/players | GET /heroes/{hero_id}/players\n*LeaguesApi* | [**leagues_get**](docs/LeaguesApi.md#leagues_get) | **GET** /leagues | GET /leagues\n*LeaguesApi* | [**leagues_league_id_get**](docs/LeaguesApi.md#leagues_league_id_get) | **GET** /leagues/{league_id} | GET /leagues/{league_id}\n*LeaguesApi* | [**leagues_league_id_matches_get**](docs/LeaguesApi.md#leagues_league_id_matches_get) | **GET** /leagues/{league_id}/matches | GET /leagues/{league_id}/matches\n*LeaguesApi* | [**leagues_league_id_teams_get**](docs/LeaguesApi.md#leagues_league_id_teams_get) | **GET** /leagues/{league_id}/teams | GET /leagues/{league_id}/teams\n*LiveApi* | [**live_get**](docs/LiveApi.md#live_get) | **GET** /live | GET /live\n*MatchesApi* | [**matches_match_id_get**](docs/MatchesApi.md#matches_match_id_get) | **GET** /matches/{match_id} | GET /matches/{match_id}\n*MetadataApi* | [**metadata_get**](docs/MetadataApi.md#metadata_get) | **GET** /metadata | GET /metadata\n*ParsedMatchesApi* | [**parsed_matches_get**](docs/ParsedMatchesApi.md#parsed_matches_get) | **GET** /parsedMatches | GET /parsedMatches\n*PlayersApi* | [**players_account_id_counts_get**](docs/PlayersApi.md#players_account_id_counts_get) | **GET** /players/{account_id}/counts | GET /players/{account_id}/counts\n*PlayersApi* | [**players_account_id_get**](docs/PlayersApi.md#players_account_id_get) | **GET** /players/{account_id} | GET /players/{account_id}\n*PlayersApi* | [**players_account_id_heroes_get**](docs/PlayersApi.md#players_account_id_heroes_get) | **GET** /players/{account_id}/heroes | GET /players/{account_id}/heroes\n*PlayersApi* | [**players_account_id_histograms_field_get**](docs/PlayersApi.md#players_account_id_histograms_field_get) | **GET** /players/{account_id}/histograms/{field} | GET /players/{account_id}/histograms\n*PlayersApi* | [**players_account_id_matches_get**](docs/PlayersApi.md#players_account_id_matches_get) | **GET** /players/{account_id}/matches | GET /players/{account_id}/matches\n*PlayersApi* | [**players_account_id_peers_get**](docs/PlayersApi.md#players_account_id_peers_get) | **GET** /players/{account_id}/peers | GET /players/{account_id}/peers\n*PlayersApi* | [**players_account_id_pros_get**](docs/PlayersApi.md#players_account_id_pros_get) | **GET** /players/{account_id}/pros | GET /players/{account_id}/pros\n*PlayersApi* | [**players_account_id_rankings_get**](docs/PlayersApi.md#players_account_id_rankings_get) | **GET** /players/{account_id}/rankings | GET /players/{account_id}/rankings\n*PlayersApi* | [**players_account_id_ratings_get**](docs/PlayersApi.md#players_account_id_ratings_get) | **GET** /players/{account_id}/ratings | GET /players/{account_id}/ratings\n*PlayersApi* | [**players_account_id_recent_matches_get**](docs/PlayersApi.md#players_account_id_recent_matches_get) | **GET** /players/{account_id}/recentMatches | GET /players/{account_id}/recentMatches\n*PlayersApi* | [**players_account_id_refresh_post**](docs/PlayersApi.md#players_account_id_refresh_post) | **POST** /players/{account_id}/refresh | POST /players/{account_id}/refresh\n*PlayersApi* | [**players_account_id_totals_get**](docs/PlayersApi.md#players_account_id_totals_get) | **GET** /players/{account_id}/totals | GET /players/{account_id}/totals\n*PlayersApi* | [**players_account_id_wardmap_get**](docs/PlayersApi.md#players_account_id_wardmap_get) | **GET** /players/{account_id}/wardmap | GET /players/{account_id}/wardmap\n*PlayersApi* | [**players_account_id_wl_get**](docs/PlayersApi.md#players_account_id_wl_get) | **GET** /players/{account_id}/wl | GET /players/{account_id}/wl\n*PlayersApi* | [**players_account_id_wordcloud_get**](docs/PlayersApi.md#players_account_id_wordcloud_get) | **GET** /players/{account_id}/wordcloud | GET /players/{account_id}/wordcloud\n*PlayersByRankApi* | [**players_by_rank_get**](docs/PlayersByRankApi.md#players_by_rank_get) | **GET** /playersByRank | GET /playersByRank\n*ProMatchesApi* | [**pro_matches_get**](docs/ProMatchesApi.md#pro_matches_get) | **GET** /proMatches | GET /proMatches\n*ProPlayersApi* | [**pro_players_get**](docs/ProPlayersApi.md#pro_players_get) | **GET** /proPlayers | GET /proPlayers\n*PublicMatchesApi* | [**public_matches_get**](docs/PublicMatchesApi.md#public_matches_get) | **GET** /publicMatches | GET /publicMatches\n*RankingsApi* | [**rankings_get**](docs/RankingsApi.md#rankings_get) | **GET** /rankings | GET /rankings\n*RecordsApi* | [**records_field_get**](docs/RecordsApi.md#records_field_get) | **GET** /records/{field} | GET /records/{field}\n*ReplaysApi* | [**replays_get**](docs/ReplaysApi.md#replays_get) | **GET** /replays | GET /replays\n*RequestApi* | [**request_job_id_get**](docs/RequestApi.md#request_job_id_get) | **GET** /request/{jobId} | GET /request/{jobId}\n*RequestApi* | [**request_match_id_post**](docs/RequestApi.md#request_match_id_post) | **POST** /request/{match_id} | POST /request/{match_id}\n*ScenariosApi* | [**scenarios_item_timings_get**](docs/ScenariosApi.md#scenarios_item_timings_get) | **GET** /scenarios/itemTimings | GET /scenarios/itemTimings\n*ScenariosApi* | [**scenarios_lane_roles_get**](docs/ScenariosApi.md#scenarios_lane_roles_get) | **GET** /scenarios/laneRoles | GET /scenarios/laneRoles\n*ScenariosApi* | [**scenarios_misc_get**](docs/ScenariosApi.md#scenarios_misc_get) | **GET** /scenarios/misc | GET /scenarios/misc\n*SchemaApi* | [**schema_get**](docs/SchemaApi.md#schema_get) | **GET** /schema | GET /schema\n*SearchApi* | [**search_get**](docs/SearchApi.md#search_get) | **GET** /search | GET /search\n*StatusApi* | [**status_get**](docs/StatusApi.md#status_get) | **GET** /status | GET /status\n*TeamsApi* | [**teams_get**](docs/TeamsApi.md#teams_get) | **GET** /teams | GET /teams\n*TeamsApi* | [**teams_team_id_get**](docs/TeamsApi.md#teams_team_id_get) | **GET** /teams/{team_id} | GET /teams/{team_id}\n*TeamsApi* | [**teams_team_id_heroes_get**](docs/TeamsApi.md#teams_team_id_heroes_get) | **GET** /teams/{team_id}/heroes | GET /teams/{team_id}/heroes\n*TeamsApi* | [**teams_team_id_matches_get**](docs/TeamsApi.md#teams_team_id_matches_get) | **GET** /teams/{team_id}/matches | GET /teams/{team_id}/matches\n*TeamsApi* | [**teams_team_id_players_get**](docs/TeamsApi.md#teams_team_id_players_get) | **GET** /teams/{team_id}/players | GET /teams/{team_id}/players\n\n\n## Documentation For Models\n\n - [BenchmarksResponse](docs/BenchmarksResponse.md)\n - [BenchmarksResponseResult](docs/BenchmarksResponseResult.md)\n - [BenchmarksResponseResultGoldPerMin](docs/BenchmarksResponseResultGoldPerMin.md)\n - [DistributionsResponse](docs/DistributionsResponse.md)\n - [DistributionsResponseCountryMmr](docs/DistributionsResponseCountryMmr.md)\n - [DistributionsResponseCountryMmrFields](docs/DistributionsResponseCountryMmrFields.md)\n - [DistributionsResponseCountryMmrRows](docs/DistributionsResponseCountryMmrRows.md)\n - [DistributionsResponseMmr](docs/DistributionsResponseMmr.md)\n - [DistributionsResponseRanks](docs/DistributionsResponseRanks.md)\n - [DistributionsResponseRanksFields](docs/DistributionsResponseRanksFields.md)\n - [DistributionsResponseRanksRows](docs/DistributionsResponseRanksRows.md)\n - [DistributionsResponseRanksSum](docs/DistributionsResponseRanksSum.md)\n - [HeroDurationsResponse](docs/HeroDurationsResponse.md)\n - [HeroItemPopularityResponse](docs/HeroItemPopularityResponse.md)\n - [HeroItemPopularityResponseEarlyGameItems](docs/HeroItemPopularityResponseEarlyGameItems.md)\n - [HeroItemPopularityResponseLateGameItems](docs/HeroItemPopularityResponseLateGameItems.md)\n - [HeroItemPopularityResponseMidGameItems](docs/HeroItemPopularityResponseMidGameItems.md)\n - [HeroItemPopularityResponseStartGameItems](docs/HeroItemPopularityResponseStartGameItems.md)\n - [HeroMatchupsResponse](docs/HeroMatchupsResponse.md)\n - [HeroObjectResponse](docs/HeroObjectResponse.md)\n - [HeroStatsResponse](docs/HeroStatsResponse.md)\n - [LeagueObjectResponse](docs/LeagueObjectResponse.md)\n - [MatchObjectResponse](docs/MatchObjectResponse.md)\n - [MatchResponse](docs/MatchResponse.md)\n - [MatchResponseBuybackLog](docs/MatchResponseBuybackLog.md)\n - [MatchResponseChat](docs/MatchResponseChat.md)\n - [MatchResponseConnectionLog](docs/MatchResponseConnectionLog.md)\n - [MatchResponseDraftTimings](docs/MatchResponseDraftTimings.md)\n - [MatchResponseKillsLog](docs/MatchResponseKillsLog.md)\n - [MatchResponsePlayers](docs/MatchResponsePlayers.md)\n - [MatchResponsePurchaseLog](docs/MatchResponsePurchaseLog.md)\n - [MatchResponseRunesLog](docs/MatchResponseRunesLog.md)\n - [MetadataResponse](docs/MetadataResponse.md)\n - [MetadataResponseCheese](docs/MetadataResponseCheese.md)\n - [ParsedMatchesResponse](docs/ParsedMatchesResponse.md)\n - [PlayerCountsResponse](docs/PlayerCountsResponse.md)\n - [PlayerHeroesResponse](docs/PlayerHeroesResponse.md)\n - [PlayerMatchesResponse](docs/PlayerMatchesResponse.md)\n - [PlayerObjectResponse](docs/PlayerObjectResponse.md)\n - [PlayerPeersResponse](docs/PlayerPeersResponse.md)\n - [PlayerProsResponse](docs/PlayerProsResponse.md)\n - [PlayerRankingsResponse](docs/PlayerRankingsResponse.md)\n - [PlayerRatingsResponse](docs/PlayerRatingsResponse.md)\n - [PlayerRecentMatchesResponse](docs/PlayerRecentMatchesResponse.md)\n - [PlayerResponse](docs/PlayerResponse.md)\n - [PlayerResponseMmrEstimate](docs/PlayerResponseMmrEstimate.md)\n - [PlayerResponseProfile](docs/PlayerResponseProfile.md)\n - [PlayerTotalsResponse](docs/PlayerTotalsResponse.md)\n - [PlayerWardMapResponse](docs/PlayerWardMapResponse.md)\n - [PlayerWinLossResponse](docs/PlayerWinLossResponse.md)\n - [PlayerWordCloudResponse](docs/PlayerWordCloudResponse.md)\n - [PlayersByRankResponse](docs/PlayersByRankResponse.md)\n - [PublicMatchesResponse](docs/PublicMatchesResponse.md)\n - [RankingsResponse](docs/RankingsResponse.md)\n - [RankingsResponseRankings](docs/RankingsResponseRankings.md)\n - [RecordsResponse](docs/RecordsResponse.md)\n - [ReplaysResponse](docs/ReplaysResponse.md)\n - [ScenarioItemTimingsResponse](docs/ScenarioItemTimingsResponse.md)\n - [ScenarioLaneRolesResponse](docs/ScenarioLaneRolesResponse.md)\n - [ScenarioMiscResponse](docs/ScenarioMiscResponse.md)\n - [SchemaResponse](docs/SchemaResponse.md)\n - [SearchResponse](docs/SearchResponse.md)\n - [TeamHeroesResponse](docs/TeamHeroesResponse.md)\n - [TeamObjectResponse](docs/TeamObjectResponse.md)\n - [TeamPlayersResponse](docs/TeamPlayersResponse.md)\n\n\n## Documentation For Authorization\n\n\n## api_key\n\n- **Type**: API key\n- **API key parameter name**: api_key\n- **Location**: URL query string\n\n\n## Author\n\n\n\n\n## Notes for Large OpenAPI documents\nIf the OpenAPI document is large, imports in python_opendota.apis and python_opendota.models may fail with a\nRecursionError indicating the maximum recursion limit has been exceeded. In that case, there are a couple of solutions:\n\nSolution 1:\nUse specific imports for apis and models like:\n- `from python_opendota.api.default_api import DefaultApi`\n- `from python_opendota.model.pet import Pet`\n\nSolution 2:\nBefore importing the package, adjust the maximum recursion limit as shown below:\n```\nimport sys\nsys.setrecursionlimit(1500)\nimport python_opendota\nfrom python_opendota.apis import *\nfrom python_opendota.models import *\n```\n\n',
    'author': 'OpenAPI Generator community',
    'author_email': 'team@openapitools.org',
    'maintainer': 'Dmitry Vasiliev',
    'maintainer_email': 'contact.vasiliev.dmitry@gmail.com',
    'url': 'https://docs.opendota.com/',
    'packages': packages,
    'package_data': package_data,
    'install_requires': install_requires,
    'python_requires': '>=3.6,<4',
}


setup(**setup_kwargs)
